<?php
/**
 * -----------------------------------------------------------------------------
 *
 * SyL - Web Application Framework for PHP
 *
 * PHP version 4 (>= 4.3.x) or 5
 *
 * Copyright (C) 2006 k.watanabe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -----------------------------------------------------------------------------
 * @package   SyL
 * @author    k.watanabe <k.watanabe@syl.jp>
 * @copyright 2006 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_Validator.php,v 1.7 2006/12/23 11:13:09 seasonstream Exp $
 * @link      http://www.syl.jp/
 * -----------------------------------------------------------------------------
 */

/**
 * 検証個別クラス
 * 
 * @package   SyL
 * @author    k.watanabe <k.watanabe@syl.jp>
 * @copyright 2006 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_Validator.php,v 1.7 2006/12/23 11:13:09 seasonstream Exp $
 * @link      http://www.syl.jp/
 */
class SyL_Validator extends SyL_Validation
{
    /**
     * 検証タイプ
     *
     * @access protected
     * @var string
     */
    var $type = '';
    /**
     * パラメータ
     *
     * @access protected
     * @var array
     */
    var $parameters = array();

    /**
     * コンストラクタ
     *
     * @access public
     * @param string エラーメッセージのフォーマット
     * @param array 検証パラメータ
     */
    function SyL_Validator($error_message, $parameters=array())
    {
        $this->error_message = $error_message;
        $this->parameters    = array_merge($this->parameters, $parameters);
        if (preg_match('/^syl_validator(.+)$/', strtolower(get_class($this)), $matches)) {
            $this->type = strtolower($matches[1]);
        }
    }

    /**
     * 個別検証オブジェクトの取得
     *
     * @access public
     * @param string 検証名
     * @param string 検証対象値
     */
    function &create($validate_name, $error_message, $parameters=array())
    {
        $validate_name = ucfirst($validate_name);
        $class_name =  'SyL_Validator' . $validate_name;
        include_once dirname(__FILE__) . DIRECTORY_SEPARATOR . 'Validator' . DIRECTORY_SEPARATOR . $class_name . '.php';
        $obj =& new $class_name($error_message, $parameters);
        return $obj;
    }

    /**
     * 検証パラメータをセット
     *
     * @access public
     * @param array 検証パラメータ
     */
    function setParameters($parameters)
    {
        $this->parameters = array_merge($this->parameters, $parameters);
    }

    /**
     * 即時検証処理を実行する
     *
     * @access public
     * @param string 検証名
     * @param string 検証対象値
     * @param array 検証パラメータ
     * @return bool true: エラー無し, false: エラーあり
     */
    function check($validate_name, $value, $parameters=array())
    {
        $validator =& SyL_Validator::create($validate_name, '', $parameters);
        return $validator->execute($value);
    }

    /**
     * 検証処理を実行する
     * ※子クラスにパラメータ名と同じ検証メソッドを定義する
     *
     * @access public
     * @param string 検証対象値
     * @return bool true: エラー無し, false: エラーあり
     */
    function execute($value)
    {
        // 必須チェック or ファイルチェック以外で、検証値が空の場合はtrue
        if (!preg_match('/^SyL_Validator(Requires?)(.*)$/i', get_class($this))) {
            // 変数なら      => SyL_ValidatorRequire
            // 1次元配列なら => SyL_ValidatorRequires
            // 2次元配列なら => SyL_ValidatorRequiresFile
            // ...強引
            if (is_array($value)) {
                $func = is_array(current($value)) ? 'requiresfile' : 'requires';
            } else {
                $func = 'require';
            }
            if (!SyL_Validator::check($func, $value)) {
                return true;
            }
        }

        return call_user_func(array(&$this, 'validate'), $value);
    }

    /**
     * 必須検証処理を実行する
     *
     * @access public
     * @param string 検証対象値
     * @param array エキストラパラメータ
     * @return bool true: エラー無し, false: エラーあり
     */
    function validate($value)
    {
        trigger_error("[SyL error] 'validate' method is not implemented in this class(" . get_class($this) . ")");
    }
}

?>
